'use strict';   // Mode strict du JavaScript

/*************************************************************************************************/
/* **************************************** DONNEES JEU **************************************** */
/*************************************************************************************************/
const NIV_FACILE 	= 1;
const NIV_NORMAL 	= 2;
const NIV_DIFFICILE = 3;

const JOUEUR = 'joueur';
const DRAGON = 'dragon';

let jeu;

/*************************************************************************************************/
/* *************************************** FONCTIONS JEU *************************************** */
/*************************************************************************************************/
function initialiserJeu()
{
	//creation de l'objet jeu
	jeu = new Object(); // = {}

	//initialisation du niveau
	jeu.niveau = getRequestInteger(1,3,"Chosir niveau: 1-facile 2-moyen 3-difficile");

	//initialisation des PVs
	switch(jeu.niveau)
	{
		case NIV_FACILE:
		jeu.pvJoueur = 100 + lancerDes(10,10);
		jeu.pvDragon = 100 + lancerDes(5,10);
		break;

		case NIV_NORMAL:
		jeu.pvJoueur = 100 + lancerDes(10,10);
		jeu.pvDragon = 100 + lancerDes(10,10);
		break;

		case NIV_DIFFICILE:
		jeu.pvJoueur = 100 + lancerDes(7,10);
		jeu.pvDragon = 100 + lancerDes(10,10);
		break;
	}

	//initialisation du tour
	jeu.tour = 1;
}

function deroulementJeu()
{
	let attaquant;
	let dommage;

	//on est dans un tour
	while(jeu.pvJoueur > 0 && jeu.pvDragon > 0)
	{
		//qui est l'attquant
		attaquant = getAttaquant();

		//calculer les points de dommages
		dommage = calculerDommage(attaquant);

		//mettre à jour les points de vie
		if(attaquant == DRAGON)
			jeu.pvJoueur -= dommage;
		else
			jeu.pvDragon -= dommage;

		//affichage
		afficherJournal(attaquant,dommage);
		afficherEtat();

		//passer au tour suivant
		jeu.tour++;
	}

}

function calculerDommage(attaquant)
{
	let dommage = lancerDes(3,6);

	switch(jeu.niveau)
	{
		case NIV_FACILE:
			if(attaquant == DRAGON)
			{
				dommage -= Math.round(dommage * lancerDes(2,6) / 100);
			}
			else //attaquant == JOUEUR
			{
				dommage += Math.round(dommage * lancerDes(2,6) / 100);
			}
			break;

		case NIV_DIFFICILE:
			if(attaquant == DRAGON)
			{
				dommage += Math.round(dommage * lancerDes(1,6) / 100);
			}
			else //attaquant == JOUEUR
			{
				dommage -= Math.round(dommage * lancerDes(1,6) / 100);
			}	
			break;
	}


	return dommage;
}

function getAttaquant()
{
	let initiativeJoueur = lancerDes(10,6);
	let initiativeDragon = lancerDes(10,6);

	if(initiativeJoueur >= initiativeDragon)
	{
		return JOUEUR;
	}

	return DRAGON;
}

function afficherEtat()
{
	if(jeu.pvJoueur > 0 && jeu.pvDragon > 0)
	{
		console.log('PV Joueur : ', jeu.pvJoueur , ' PV Dragon :', jeu.pvDragon);
	}

	if(jeu.pvDragon <= 0)
	{
		console.log('PV Joueur : ', jeu.pvJoueur , ' PV Dragon : GAME OVER');	
	}

	if(jeu.pvJoueur <= 0)
	{
		console.log('PV Joueur : GAME OVER PV Dragon :',jeu.pvDragon);	
	}
	
}

function afficherJournal(attaquant,dommage)
{
	console.log('TOUR N°:',jeu.tour);
	if(attaquant == JOUEUR)
		console.log
		('Vous êtes le plus rapide, vous attaquez le dragon et lui infligez ',
			dommage,' points de dommage !');
	else
		console.log
		('Le dragon prend l\'initiative, vous attaque et vous inflige ',
			dommage,' points de dommage !');

}

function afficherFinJeu()
{
	console.log('FIN DE LA PARTIE');

	if(jeu.pvJoueur > 0)
		console.log('BRAVO vous avez battu le dragon!');
	else
		console.log('Vous avez perdu le combat, le dragon vous a carbonisé !');

}
/*************************************************************************************************/
/* ************************************** CODE PRINCIPAL *************************************** */
/*************************************************************************************************/


initialiserJeu();
console.log('Que la fête commence!!!');
afficherEtat();
deroulementJeu();
afficherFinJeu();